﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using System.IO;
using System.Text;

public partial class ManualPdfExport : System.Web.UI.Page 
{
    enum PdfOutputModes { None, SendToBrowser, SaveOnServer };
    PdfOutputModes mode = PdfOutputModes.None;

    protected void SaveToServerButton_Click(object sender, EventArgs e)
    {
        mode = PdfOutputModes.SaveOnServer;
        RadGrid1.MasterTableView.ExportToPdf();
    }

    protected void SendToResponseButton_Click(object sender, EventArgs e)
    {
        mode = PdfOutputModes.SendToBrowser;
        RadGrid1.MasterTableView.ExportToPdf();
    }

    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable tbl = new DataTable();
        tbl.Columns.Add("japanese");
        tbl.Columns.Add("chinese");
        tbl.Columns.Add("hindi");
        tbl.Rows.Add("ひらがな 平仮名", "汉语", " हिन्दी");
        tbl.Rows.Add("カタカナ 片仮名","漢語","मानक हिन्दी");
        RadGrid1.DataSource = tbl;
    }

    protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
    {
        if (mode != PdfOutputModes.None && e.ExportType == ExportType.Pdf)
        {
            byte[] output = Encoding.GetEncoding(1252).GetBytes(e.ExportOutput);
            string fileName = RadGrid1.ExportSettings.FileName + ".pdf";
            string fileNamePath = Server.MapPath("~/" + fileName);

            Response.ClearContent();
            Response.ClearHeaders();
            Response.Cache.SetCacheability(HttpCacheability.Private);
            Response.ContentType = "application/pdf";
            Response.AppendHeader("Content-Length", output.Length.ToString());
            Response.AppendHeader("Content-Disposition", "attachment; filename=" + fileName);

            if (mode == PdfOutputModes.SaveOnServer)
            {
                File.WriteAllBytes(fileNamePath, output);
                Response.WriteFile(fileNamePath);
            }
            else
            {
                Response.BinaryWrite(output);
            }

            HttpContext.Current.ApplicationInstance.CompleteRequest();
        }
    }
}
